/*-
 * Copyright (c) 2003-2006 Andrey Simonenko
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *   @(#)$Id: config_add.h,v 1.1.2.1 2006/12/21 19:52:12 simon Exp $
 */

#if defined(WITH_LIMITS) || defined(WITH_THRESHOLDS)
# define WITH_ANY_LIMITS
#endif

#ifdef HAVE_STDINT_H
# include <stdint.h>
#endif

#ifdef HAVE_INTTYPES_H
# include <inttypes.h>
#endif

#ifndef UINT32_MAX
# define UINT32_MAX	0xffffffffU
#endif

#ifndef INT32_MAX
# define INT32_MAX	0x7fffffff
#endif

#ifndef UINT64_C
# if SIZEOF_LONG == 4
#  define UINT64_C(c)	(c ## ULL)
# else
#  define UINT64_C(c)	(c ## UL)
# endif
#endif /* !UINT64_C */

#ifndef INT64_C
# if SIZEOF_LONG == 4
#  define INT64_C(c)	(c ## LL)
# else
#  define INT64_C(c)	(c ## L)
# endif
#endif /* !INT64_C */

#ifndef UINT64_MAX
# define UINT64_MAX	UINT64_C(0xffffffffffffffff)
#endif

#ifndef INT64_MAX
# define INT64_MAX	INT64_C(0x7fffffffffffffff)
#endif

#ifndef HAVE_U_CHAR
typedef unsigned char u_char;
#endif

#ifndef HAVE_U_INT
typedef unsigned int u_int;
#endif

#ifndef HAVE_U_LONG
typedef unsigned long u_long;
#endif

#ifndef lint
# ifdef HAVE_ATTR_FORMAT
#  define ATTR_FORMAT(x, y, z) __attribute__ ((format (x, y, z)))
# else
#  define ATTR_FORMAT(x, y, z)
# endif
#else
# undef ATTR_NORETURN
# undef ATTR_PACKED
# undef ATTR_UNUSED
#endif /* !lint */
